#ifndef UI_MAIN_H
#define UI_MAIN_H

#include <glib-object.h>

#define BMP_TYPE_WINDOW_MAIN		  (bmp_window_main_get_type ())
#define BMP_WINDOW_MAIN(obj)		  (G_TYPE_CHECK_INSTANCE_CAST ((obj), BMP_TYPE_WINDOW_MAIN, BmpWindowMain))
#define BMP_IS_WINDOW_MAIN(obj)		  (GTK_CHECK_TYPE ((obj), BMP_TYPE_WINDOW_MAIN))
#define BMP_WINDOW_MAIN_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS ((obj), BMP_TYPE_WINDOW_MAIN, BmpWindowMainClass))
#define BMP_WINDOW_MAIN_CLASS(klass)	  (G_TYPE_CHECK_CLASS_CAST ((klass), BMP_TYPE_WINDOW_MAIN, BmpWindowMainClass))
#define BMP_IS_WINDOW_MAIN_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BMP_TYPE_WINDOW_MAIN))

typedef struct _BmpWindowMain BmpWindowMain;
typedef struct _BmpWindowMainClass BmpWindowMainClass;
typedef struct _BmpWindowMainPrivate BmpWindowMainPrivate;

struct _BmpWindowMain {
	GObject parent;

        BmpWindowMainPrivate *private;

	GtkWidget *window;
};

struct _BmpWindowMainClass {
	GObjectClass parent;
};

typedef enum {
	BMP_UI_MAIN_SLIDER_VOLUME,
	BMP_UI_MAIN_SLIDER_BALANCE,
	BMP_UI_MAIN_SLIDER_SEEK,
	
	BMP_UI_MAIN_N_SLIDERS
} BmpUIMainSliders;

GType
bmp_window_main_get_type (void);

BmpWindowMain*
bmp_window_main_new (void);
 
void 
bmp_window_main_configure(BmpWindowMain *window_main);

void
bmp_window_main_iconify (BmpWindowMain *self);

void
bmp_window_main_set_seek_request (BmpWindowMain *window_main, gint seek_request);

#endif /* UI_MAIN_H */
